import FS from 'node:fs'

const intx = async (url, options = {}, after = (x => x)) => {
  const f = await fetch(`https://${url}`, options)
  const o = await f.json() || await f.text()
  return after(o)
}

const get = async (url, headers = {}) => {
  const f = await fetch(`https://${url}`, { headers: headers })
  const j = await f.json()
  return j
}

const post = async (url, headers) => {
  headers.method = 'POST'
  return await GET(url, headers)
}

const save = async (o, fn) => {
  FS.writeFileSync(`./${fn}`, JSON.stringify(o, null, 2))
}

const load = (fn) => {
  return JSON.parse(FS.readFileSync(`./${fn}`, 'utf8'))
}

export { intx, get, post, save, load }

if(process.argv[2] == 'test')
  console.log(await intx('httpbin.org/get', {}, x=>x.origin))